#include <stdio.h>
#include <assert.h>
#include "midi-utils.h"

int main(void) {
	FILE* f = fopen("cases.txt", "r");
	if (!f) {
		return -1;
	}
	char read_note_name[255] = "";
	unsigned int read_note_value;
	while (!feof(f)) {
		fscanf(f, "%s %d\n", read_note_name, &read_note_value);
		unsigned int actual_note_value = MIDI_GetNoteFromName(read_note_name);
		printf("MIDI_GetNoteFromName(\"%s\")...", read_note_name);
		printf("(%d == %d) ", read_note_value, actual_note_value);
		assert(read_note_value == actual_note_value);
		printf("OK!\n");

		if (read_note_value != 255u || !strcmp(read_note_name, "D#21")) {
			printf("MIDI_GetNoteName(%d)...", read_note_value);
			char* actual_note_name = MIDI_GetNoteName(read_note_value);

			printf("(%s == %s) ", read_note_name, actual_note_name);
			assert(!strcmp(read_note_name, actual_note_name));

			printf("OK!\n");
		}
	}

	fclose(f);
	return 0;
}
